
// Enter your examination number here

unit Question2_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, DB, ExtCtrls, StdCtrls,
  ComCtrls, Grids, DBGrids, Buttons, ADODB, Math, DateUtils,
  ConnectDB_U;

type
  TfrmQuestion2 = class(TForm)
    pgcDBAdmin: TPageControl;
    tabsQ2SQL: TTabSheet;
    btnQ2_1_5: TBitBtn;
    grpresults: TGroupBox;
    dbgrdSQL: TDBGrid;
    btnQ2_1_1: TBitBtn;
    btnQ2_1_2: TBitBtn;
    btnQ2_1_4: TBitBtn;
    b: TTabSheet;
    grpQ2_2_1: TGroupBox;
    redQ2_2_1: TRichEdit;
    btnQ2_2_1: TButton;
    dbgLecturers: TDBGrid;
    dbgCourses: TDBGrid;
    grpQ2_2_2: TGroupBox;
    btnQ2_2_2: TButton;
    pnlBtns: TPanel;
    bmbClose: TBitBtn;
    bmbRestoreDB: TBitBtn;
    btnQ2_1_3: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bmbRestoreDBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnQ2_1_4Click(Sender: TObject);
    procedure btnQ2_1_3Click(Sender: TObject);
    procedure btnQ2_1_2Click(Sender: TObject);
    procedure btnQ2_1_1Click(Sender: TObject);
    procedure btnQ2_1_5Click(Sender: TObject);
    procedure btnQ2_2_1Click(Sender: TObject);
    procedure btnQ2_2_2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion2: TfrmQuestion2;
  dbCONN: TConnection;
  // --- Global variables provided ---
  tblLecturers, tblCourses: TADOTable;

implementation

{$R *.dfm}

procedure TfrmQuestion2.bmbRestoreDBClick(Sender: TObject);
begin
  // Restores the Database
  dbCONN.RestoreDatabase;
  redQ2_2_1.Clear;
  dbCONN.SetupGrids(dbgLecturers, dbgCourses, dbgrdSQL);
end;

procedure TfrmQuestion2.btnQ2_1_1Click(Sender: TObject);
var
  sSQL1: String;
begin
  // 2.1.1 Large courses

  sSQL1 := '';

  // Provided code - do not change
  dbCONN.runSQL(sSQL1);
end;

procedure TfrmQuestion2.btnQ2_1_2Click(Sender: TObject);
var
  sSQL2: String;
begin
  // 2.1.2 Lecturer gender

  sSQL2 := '';

  // Provided code - do not change
  dbCONN.runSQL(sSQL2);
end;

procedure TfrmQuestion2.btnQ2_1_3Click(Sender: TObject);
var
  sSQL3: String;
begin
  // 2.1.3 Courses with multilingual lecturers

  sSQL3 := '';

  // Provided code - do not change
  dbCONN.runSQL(sSQL3);
end;

procedure TfrmQuestion2.btnQ2_1_4Click(Sender: TObject);
var
  sSQL4: String;
begin
  // 2.1.4 Lecturer salaries

  sSQL4 := '';

  // Provided code - do not change
  dbCONN.runSQL(sSQL4);
end;

procedure TfrmQuestion2.btnQ2_1_5Click(Sender: TObject);
var
  sSQL5: String;
  bChanged: boolean;
begin
  // 2.1.5 Change online option

  sSQL5 := '';

  // Provided code - do not change
  dbCONN.ExecuteSQL(sSQL5, bChanged);
  if bChanged then
   begin
    ShowMessage('Content of database changed successfully.');
    tblCourses.Refresh;
    tblCourses.First;
    pgcDBAdmin.TabIndex := 1;
   end;
end;

procedure TfrmQuestion2.btnQ2_2_1Click(Sender: TObject);
var
  iCountCourses, iSumDuration: integer;
  rAverageDuration: real;
begin
  // Provided code
  redQ2_2_1.Clear;

  // 2.2.1 Average duration of courses


end;

procedure TfrmQuestion2.btnQ2_2_2Click(Sender: TObject);
begin
  // 2.2.2 Register new lecturer


end;

// ================================================================
// {$ENDREGION}
// ================================================================
// {$REGION 'Provided code: Setup DB connections - DO NOT CHANGE!'}
// ================================================================

procedure TfrmQuestion2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Disconnects from database and closes all open connections
  dbCONN.dbDisconnect;
end;

procedure TfrmQuestion2.FormCreate(Sender: TObject);
begin
  // Provided code
  redQ2_2_1.Paragraph.TabCount := 2;
  redQ2_2_1.Paragraph.Tab[0] := 100;
  redQ2_2_1.Paragraph.Tab[1] := 150;
  redQ2_2_1.Paragraph.Tab[2] := 200;
end;

procedure TfrmQuestion2.FormShow(Sender: TObject);
begin
  // Sets up the connection to database and opens the tables.
  dbCONN := TConnection.Create;
  dbCONN.dbConnect;
  tblLecturers := dbCONN.tblOne;
  tblCourses := dbCONN.tblMany;
  dbCONN.SetupGrids(dbgLecturers, dbgCourses, dbgrdSQL);
  pgcDBAdmin.ActivePageIndex := 0;
  dbCONN.RestoreDatabaseBegin;
  redQ2_2_1.Clear;
  dbCONN.SetupGrids(dbgLecturers, dbgCourses, dbgrdSQL);
end;

// =====================================================
// {$ENDREGION}

end.
