
// Enter your examination number here

unit Question4_U;

interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, ComCtrls,
  ExtCtrls, jpeg, math;

type
  TfrmQuestion4 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    btnQ4_2_2: TButton;
    redQ4: TRichEdit;
    GroupBox1: TGroupBox;
    btnQ4_2_1: TButton;
    pgcQ4: TPageControl;
    tshQ4_1: TTabSheet;
    tshQ4_2: TTabSheet;
    btnQ4_1: TButton;
    lstQ4_1: TListBox;
    GroupBox2: TGroupBox;
    procedure btnQ4_2_2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnQ4_2_1Click(Sender: TObject);
    procedure btnQ4_1Click(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
    // Provided code
    procedure populate;
    procedure display;
  end;

var
  frmQuestion4: TfrmQuestion4;
  // Provided code for Question 4.1
  arrCodes: array [1 .. 5] of String = (
    'An7J*Q#D&N',
    'pL78K#$.%BV',
    '89@FGh0&Y56#$Q',
    'Bn4m321&*#T',
    'P2QwER%$#a'
  );

  // Provided code for Question 4.2
  arrDays: array [1 .. 5] of String = (
    'Mon.',
    'Tue.',
    'Wed.',
    'Thu.',
    'Fri.'
  );
  arrSubjectCodes: array [1 .. 5] of String = (
    'IT',
    'HL',
    'ACC',
    'PHY',
    'MAT'
  );

  arrTimeTable: array [1 .. 5, 1 .. 7] of String;

implementation

{$R *.dfm}

procedure TfrmQuestion4.btnQ4_1Click(Sender: TObject);
begin
  // 4.1 Codes


end;

procedure TfrmQuestion4.btnQ4_2_1Click(Sender: TObject);
begin
  // 4.2.1 Extra IT periods



  // Provided code
  display;
end;

procedure TfrmQuestion4.btnQ4_2_2Click(Sender: TObject);
begin
  // 4.2.2 Group IT



  // Provided code
  display;
end;



// ========================================================
// Provided code -  Do not change
// ========================================================

procedure TfrmQuestion4.populate;
var
  sSubjCode: String;
  iPeriod, iRand, iRow, iCol, iCnt: integer;
  arrLocal: array [1 .. 5] of String;
begin
  for iCnt := 1 to 5 do
  begin
    repeat
      iRand := RandomRange(1, 6);
      if length(arrLocal[iRand]) = 0 then
        arrLocal[iCnt] := arrSubjectCodes[iCnt];
    until length(arrLocal[iCnt]) > 0;
  end;
  for iCol := 1 to 5 do
  begin
    for iRow := 1 to 5 do
    begin
      repeat
        iRand := RandomRange(1, 8);
      until (arrTimeTable[iRow, iRand] = '');
      arrTimeTable[iRow, iRand] := arrLocal[iCol];
    end;
  end;
  display;
end;

procedure TfrmQuestion4.FormShow(Sender: TObject);
begin
  redQ4.Paragraph.TabCount := 9;
  redQ4.Paragraph.Tab[0] := 50;
  redQ4.Paragraph.Tab[1] := 100;
  redQ4.Paragraph.Tab[2] := 150;
  redQ4.Paragraph.Tab[3] := 200;
  redQ4.Paragraph.Tab[4] := 250;
  redQ4.Paragraph.Tab[5] := 300;
  redQ4.Paragraph.Tab[6] := 350;
  redQ4.Paragraph.Tab[7] := 400;
  redQ4.Paragraph.Tab[8] := 450;
  display;
  populate;

end;

procedure TfrmQuestion4.display;
var
  iRow, iCol, iCnt: integer;
  sLine: String;
begin
  sLine := #9;
  for iCnt := 1 to 7 do
    sLine := sLine + intToStr(iCnt) + #9;
  redQ4.Clear;
  redQ4.Lines.Add(sLine);
  for iRow := 1 to 5 do
  begin
    sLine := arrDays[iRow];
    for iCol := 1 to 7 do
    begin
      sLine := sLine + #9 + arrTimeTable[iRow, iCol];
    end;
    redQ4.Lines.Add(sLine);
  end;
end;

// ========================================================
// End of provided code
// ========================================================

end.
